/* ACDPlay_protos.h */

void CopyRange(struct Application *);

BOOL HandleEvents(struct Application *);
BOOL HandleCommodityEvents(struct Application *);
void HandleScreenNotify(struct Application *);
void HandleAppIconEvents(struct Application *);

ULONG ExamineFileLength(char *);
ULONG ExamineDiskSpace(char *);
char *OpenFile(char *);
BOOL SaveFile(char *, char *, LONG);
struct List *GetDirContents(char *);
BOOL GetFileName(struct Application *, WORD);
void ReadConfig(struct Application *, char *);
BOOL SaveConfig(struct Application *, char *);
void ReadArguments(struct Application *);

ULONG DirectChoice(struct Application *, UWORD);
ULONG LoadCD(struct Application *);
ULONG UnLoadCD(struct Application *);
ULONG EjectButton(struct Application *);
ULONG JumpBackwardButton(struct Application *);
ULONG JumpForwardButton(struct Application *);
ULONG SearchBackwardButton(struct Application *, WORD);
ULONG SearchForwardButton(struct Application *, WORD);
ULONG StopButton(struct Application *);
ULONG PauseButton(struct Application *);
ULONG PlayButton(struct Application *);
ULONG Trackslider(struct Application *, UWORD);
BOOL SaveTitles(struct Application *);

void ProgramStart(struct Application *);
BOOL ProgramDelete(struct Application *);
BOOL ProgramAppendElement(struct Application *, UWORD);
BOOL ProgramDeleteElement(struct Application *, ULONG);
BOOL ProgramCopyAll(struct Application *);
BOOL ProgramSave(struct Application *);
BOOL ProgramLoad(struct Application *);

BOOL ProgramNext(struct Application *);
void ProgramPrev(struct Application *);
struct ProgramTitleNode *GetRandomProgram(struct Application *);
UBYTE GetRandomTrack(struct Application *);
void InitRandomTracks(struct List *);
void CDPlayVerify(struct CDStruct *, UBYTE);

struct Application *CreateApplication(char *);
void DeleteApplication(struct Application *);
BOOL OpenApplication(struct Application *);
void CloseApplication(struct Application *);
BOOL MakeVisuals(struct Application *, WORD);
BOOL MakeMenus(struct Application *);
BOOL OpenAppWin(struct Application *, WORD);
void CloseAppWin(struct Application *, WORD, BOOL);
void StripIntuiMessages(struct Window *);

void UpdateGadgets(struct Application *);
void UpdateTrackNumber(struct Application *);
void UpdateCurrentTrack(struct Application *);
void UpdateStatus(struct Application *);
void UpdateTimePercent(struct Application *, int);
void UpdateTimeGadget(struct Application *);
void UpdateUnitLUN(struct Application *);
void TestABRepeat(struct Application *);

void MakeInterior(struct Application *, WORD);
void UpdateWinTitle(struct Application *);
void DoTimeBuffer(struct Application *);
void DoABBuffer(struct Application *);
void DoSizeBuffer(struct Application *);
float CalcAudioSize(LONG, LONG, LONG);
void DoCDDBID(struct CDStruct *);

void CreateAppIcon(struct Application *);
void FreeAppIcon(struct Application *);
void MakeBusy(struct Application *, BOOL);
BOOL CreateCommodity(struct Application *);
BOOL OpenCDStruct(struct CDStruct *);
void FreeCDStruct(struct CDStruct *);
BOOL UpdateCDTitles(struct Application *);
BOOL IsDefaultTitle(char *, UBYTE);

void RefreshBevelBox(struct RastPort *, struct BevelBox *, WORD, WORD);
void SelectGadget(struct Application *, WORD, WORD, BOOL);
void ChangeButtonText(struct Application *, WORD, WORD, char *);
void ManageNewSize(struct Application *, WORD);
void RemoveMenus(struct Application *);
void AttachMenus(struct Application *);
void AdjustNewSize(struct Application *, WORD, WORD, WORD);
WORD TextWidth(char *, struct TextAttr *);
WORD FindWidest(char **, struct TextAttr *);
char *NumToStr(LONG);
LONG RandomNum(LONG, LONG);
LONG FitInteger(LONG, LONG, LONG);
LONG InsertBoolean(LONG, LONG, BOOL);

BOOL CreateScrollObject(struct Scroll *);
void UpdateScrollObject(struct Scroll *, struct Window *);
void DisposeScrollObject(struct Scroll *);
BOOL GetPubScreenName(struct Screen *, char *);
BOOL GetPubScreenList(struct Application *);
void FreeList(struct List *);
Node *FindNode(struct List *, ULONG);

extern STRPTR GetString(register __a0 struct LocaleInfo *li, register __d0 ULONG id);

#include "AsmLib/QuickFuncs.h"