/*
** ppc.library emulation
** (c)1998-2000 Frank Wille <frank@phoenix.owl.de>
**
** PPC task attributes, exception handlers, etc.
**
** V0.6e (14.05.1999) phx
**       created
*/

#include "ppclibemu.h"
#include "taskobject.h"
#include <powerup/ppclib/ppc.h>
#include <powerup/ppclib/tasks.h>
#include "mpsema_protos.h"
#include "warpos_protos.h"

#ifdef KERNEL_DEBUG
#define KDB(x) x
#else
#define KDB(x)
#endif

extern void DPrintf(struct PPCLibBase *,char *,...);



BOOL __saveds ppctaskattr(struct PPCLibBase *ppcbase,struct TaskObject *to,
                          ULONG tag,ULONG data,ULONG *vptr,BOOL ppc)
{
  struct PPCBase *wosbase = ppcbase->PowerPCBase;
  BOOL ret = TRUE;

  __set_r2(ppcbase->WOSLinkerDB);
  obtainMPSemaphorePPC(ppcbase,&to->mpSema);

  switch (tag) {
    case PPCTASKINFOTAG_PRIORITY:
      to->n.ln_Pri = (long)data;
      __SetNiceValue(wosbase,to->this,-(LONG)data);
      break;

    case PPCTASKTAG_EXTUSERDATA:
      to->Ext_UserData = data;
      break;

    case PPCTASKINFOTAG_INPUTHANDLE:
      to->inputhandle = (BPTR)data;
      break;

    case PPCTASKINFOTAG_OUTPUTHANDLE:
      to->outputhandle = (BPTR)data;
      break;

    case PPCTASKINFOTAG_ERRORHANDLE:
      to->errorhandle = (BPTR)data;
      break;

    default:
      KDB(DPrintf(ppcbase,"\tTag 0x%08lx not implemented\n",tag));
      ret = FALSE;
      break;
  }

  releaseMPSemaphorePPC(ppcbase,&to->mpSema);
  return (ret);
}
