/*
** ppc.library emulation
** (c)1998-2000 Frank Wille <frank@phoenix.owl.de>
**
** PowerUp kernel symbols.
** The order must be the same as in kernelcall.s and in libinit.asm.
**
** V0.5c (20.03.1999) phx
**       Removed PPCAlert(), PPCPutMessage() and PSYSCALL_xxx(),
**       which are not accessible in the original kernel.
** V0.4  (23.11.1998) phx
**       Included all kernel symbols of ppc.library V46.19,
**       except _KERNEL_xxxxx.
** V0.1  (15.11.1998) phx
**       First partially working ppc.library emulation. Synchronous PPC
**       tasks, started by runelf, which only use the basic PowerUp kernel
**       functions for I/O, memory and context-switch seem to work fine.
** V0.0  (13.11.1998) phx
**       created
*/


const char *kernel_syms[] = {
  "PPCAdd64",
  "PPCAdd64p",
  "PPCAddHead",
  "PPCAddHeadSync",
  "PPCAddPortList",
  "PPCAddTail",
  "PPCAddTailSync",
  "PPCAllocMem",
  "PPCAllocPooled",
  "PPCAllocSignal",
  "PPCAllocVec",
  "PPCAllocVecPooled",
  "PPCAnd64",
  "PPCAnd64p",
  "PPCAsl64",
  "PPCAsl64p",
  "PPCAsr64",
  "PPCAsr64p",
  "PPCAttemptSemaphore",
  "PPCAttemptSemaphoreByName",
  "PPCAttemptSemaphoreShared",
  "PPCCacheFlush",
  "PPCCacheFlushAll",
  "PPCCacheInvalid",
  "PPCCallM68k",
  "PPCCallOS",
  "PPCClose",
  "PPCCloseLibrary",
  "PPCCmp64",
  "PPCCmp64p",
  "PPCCoerceMethodA",
  "PPCCreateMessage",
  "PPCCreatePool",
  "PPCCreatePort",
  "PPCCreatePortList",
  "PPCCreateSemaphore",
  "PPCCreateTask",
  "PPCCreateTimerObject",
  "PPCDeleteMessage",
  "PPCDeletePool",
  "PPCDeletePort",
  "PPCDeletePortList",
  "PPCDeleteSemaphore",
  "PPCDeleteTimerObject",
  "PPCDivRem64",
  "PPCDivRem64p",
  "PPCDivs64",
  "PPCDivs64p",
  "PPCDivu64",
  "PPCDivu64p",
  "PPCDoMethodA",
  "PPCDoSuperMethodA",
  "PPCEnqueue",
  "PPCEnqueueSync",
  "PPCFindName",
  "PPCFindNameSync",
  "PPCFindTagItem",
  "PPCFindTask",
  "PPCFinishTask",
  "PPCfprintf",
  "PPCFreeMem",
  "PPCFreePooled",
  "PPCFreeSignal",
  "PPCFreeVec",
  "PPCFreeVecPooled",
  "PPCGetAttr",
  "PPCGetLibSymbol",
  "PPCGetMessage",
  "PPCGetMessageAttr",
  "PPCGetObjectAttrs",
  "PPCGetPortListAttr",
  "PPCGetTagData",
  "PPCGetTaskAttr",
  "PPCGetTimerObject",
  "PPCHandleTimerJobs",
  "PPCInput",
  "PPCInsert",
  "PPCInsertSync",
  "PPCkprintf",
  "PPCLoadObject",
  "PPCLoadObjectTagList",
  "PPCLockBus",
  "PPCLsl64",
  "PPCLsl64p",
  "PPCLsr64",
  "PPCLsr64p",
  "PPCMods64",
  "PPCMods64p",
  "PPCModu64",
  "PPCModu64p",
  "PPCMuls64",
  "PPCMuls64p",
  "PPCMulu64",
  "PPCMulu64p",
  "PPCNeg64",
  "PPCNeg64p",
  "PPCNewList",
  "PPCNextTagItem",
  "PPCObtainPort",
  "PPCObtainSemaphore",
  "PPCObtainSemaphoreByName",
  "PPCObtainSemaphoreShared",
  "PPCOpen",
  "PPCOpenLibrary",
  "PPCOr64",
  "PPCOr64p",
  "PPCOutput",
  "PPCprintf",
  "PPCRawDoFmt",
  "PPCRead",
  "PPCReadByte",
  "PPCReadLong",
  "PPCReadWord",
  "PPCReleasePort",
  "PPCReleaseSemaphore",
  "PPCRemHead",
  "PPCRemHeadSync",
  "PPCRemove",
  "PPCRemoveSync",
  "PPCRemPortList",
  "PPCRemTail",
  "PPCRemTailSync",
  "PPCReplyMessage",
  "PPCRevision",
  "PPCSeek",
  "PPCSendMessage",
  "PPCSetPortListAttr",
  "PPCSetSignal",
  "PPCSetTaskAttr",
  "PPCSetTimerObject",
  "PPCSignal",
  "PPCsprintf",
  "PPCSub64",
  "PPCSub64p",
  "PPCUnLoadObject",
  "PPCUnLockBus",
  "PPCVersion",
  "PPCvfprintf",
  "PPCvkprintf",
  "PPCvprintf",
  "PPCvsprintf",
  "PPCWait",
  "PPCWaitPort",
  "PPCWaitPortList",
  "PPCWrite",
  "PPCWriteByte",
  "PPCWriteLong",
  "PPCWriteWord",
  "PPCXor64",
  "PPCXor64p",
  "memcpy",
  "strcmp",
  "strcpy",
  "strlen",
  "__adddi3",
  "__anddi3",
  "__ashldi3",
  "__ashrdi3",
  "__cmpdi2",
  "__divdi3",
  "__fixdfdi",
  "__fixsfdi",
  "__fixunsdfdi",
  "__fixunssfdi",
  "__floatdidf",
  "__floatdisf",
  "__floatunsdidf",
  "__iordi3",
  "__lmulq",
  "__lshldi3",
  "__lshrdi3",
  "__moddi3",
  "__muldi3",
  "__negdi2",
  "__qdivrem",
  "__subdi3",
  "__ucmpdi2",
  "__udivdi3",
  "__umoddi3",
  "__xordi3",
  0
};
