/*
** ppc.library emulation
** (c)1998-2000 Frank Wille <frank@phoenix.owl.de>
**
** M68k support functions
**
** V0.8  (29.06.2000) phx
**       SignalPPCor68k() sends a signal to a PPC or M68k task.
** V0.4c (21.01.1999) phx
**       Rewritten from scratch. Always use 32-byte aligned memory.
** V0.1  (15.11.1998) phx
**       First partially working ppc.library emulation. Synchronous PPC
**       tasks, started by runelf, which only use the basic PowerUp kernel
**       functions for I/O, memory and context-switch seem to work fine.
** V0.0  (02.11.1998) phx
**       created
*/

#ifndef SUPP_H
#define SUPP_H

#include "ppclibemu.h"
#include <exec/memory.h>
#include <exec/lists.h>
#include <proto/exec.h>
#include <proto/powerpc.h>


void *alloc32(ULONG,struct PPCLibBase *);
void *alloc32c(ULONG,struct PPCLibBase *);
#define free32(p,b) __FreeVec32(p,(b)->PowerPCBase)
void *newpool32(ULONG,struct PPCLibBase *);
#if 0 /* powerpc.library V15 */
#define freepool32(p,b) __DeletePool32((p),(b)->PowerPCBase)
#else
void freepool32(void *,struct PPCLibBase *);
#endif
void *allocp32(void *,ULONG,struct PPCLibBase *);
char *allocpstr(void *,char *,struct PPCLibBase *);
void Dprintf(struct PPCLibBase *,char *,...);
void SignalPPCor68k(struct Task *,ULONG,struct PPCLibBase *);


#endif /* SUPP_H */
